const fs = require('fs')

module.exports = (api, opts, rootOpts) => {
    // 扩展依赖
    api.extendPackage({
        dependencies: {
            'echarts': '^4.2.1',
            'resize-observer-polyfill': '^1.5.1'
        },
        devDependencies: {
            'compression-webpack-plugin': '^2.0.0',
            'svg-sprite-loader': '^4.1.3'
        }
    })

    api.onCreateComplete(() => {
        const mainFile = api.resolve('./src/main.js')

        let mainContent = fs.readFileSync(mainFile, {encoding: 'utf-8'})
        const lines = mainContent.split(/\r?\n/g).reverse()
        const lastImportIndex = lines.findIndex(line => line.match(/^import/))
        lines[lastImportIndex] += `\nimport './icons' // svg-icon`

        mainContent = lines.reverse().join('\n')
        fs.writeFileSync(mainFile, mainContent, {encoding: 'utf-8'})
    })

    if (opts.addSvgSprite) {
        api.render('./template', {
            ...opts
        })
    }
}